//
//  XYSDK.h
//  Printer
//
//  Created by apple on 16/4/6.
//  Copyright © 2016年 Admin. All rights reserved.
//


/*
 
 
 /*
 Introduction: you need to add a system dependency library using SDK
 SystemConfiguration.framework
 CFNetwork.framework
 CoreBluetooth.framework
 
 
 In the printerIosSdk usr file, the visible header files (.H files) are: BLEManager.h, WIFIManager.h, TscCommand.h, PosCommand.h, ImageTranster.h, and POSSDK.h.
 This.H file contains Bluetooth and WiFi: send BLEMananger.h and WIFIManager, a method for receiving data and the need to follow the instructions of the agent, and packaging tools: TscCommand, PosCommand, image processing category: ImageTranster;
 Documentation posSDK.h
 BLEManager.h is the Bluetooth management class that handles Bluetooth connectivity, correlation, and the sending of POS commands
 The use of [BLEManager sharedInstance] method to create a single case management object, create and follow the agent, agent to achieve the method. Call the startScan method to scan, and get the scan results in proxy method didUpdatePeripheralList. ConnectDevice: is a Bluetooth connection method to connect to the specified peripheral.BLEManager has a writePeripheral attribute, which specifies the write data to the outside, do not specify a default the last connected peripherals.
 POSWIFIManager.h is a WiFi management class, send the connection of WiFi and bar code instructions. A single connection can use one method of [POSWIFIManager shareWifiManager] cases create a connection object, and follow the agent, ConnectWithHost:port:completion: is the method of connection with the specified IP port, a block callback is successful. When multiple connections using [[POSWIFIManager alloc] init] method to initialize multiple management the object, and save, use the corresponding object to send instructions.
 TscCommand.h barcode instruction wrapper class, all returned values are NSData type;
 The PosCommand.h, POS instructions wrapper tool class returns all of the NSData types
 Both methods in the instruction class class are class methods, called directly by the class name, and the return values are NSData types that can be used to send data directly
 Both Bluetooth and WiFi connection implementations are required to follow the proxy, in detail refer to the sample code
 Specific methods for sending data in BLEManager.h and WIFIManager.h are both - (void), WriteCommandWithData: (NSData *) data, and the method of bringing back the tune
 - - (void) WriteCommandWithData: (NSData *) data, callBack: (TSCCompletionBlock) block;
 
 
 Instructions for using Bluetooth management classes:
 First of all: set up a proxy using [BLEManager sharedInstance] single instance method to create management object, and implementation of proxy method. Note: when the object is created after BLEManager, Bluetooth has opened the scan, scan results were saved. At this time, in the proxy implementation method - (void) didUpdatePeripheralList: (NSArray * peripherals * NSArray (RSSIList:) rssiList);, can get the scan results by scanning devices, can be connected, connectDevice: junction; success or failure will call the proxy method - (void) didConnectPeripheral: (CBPeripheral * peripheral); and (void) - didFailToConnectPeripheral: (CBPeripheral * peripheral) error: (NSError * error); method.
 After a successful connection, to obtain feature writing data, you can call the method of sending data, recommend the use of WriteCommandWithData: method in the data transmission. After sending callback proxy method didWriteValueForCharacteristic: (CBCharacteristic * character) error: (NSError * error); can be judged by error data transmission is successful, then do the corresponding operation. You can use the WriteCommandWithData:callblock: method to send success with block callback.
 @protocol BLEManagerDelegate <NSObject>
 The Bluetooth device / Executive
 - - (void) didUpdatePeripheralList: (NSArray *), peripherals, RSSIList: (NSArray *) rssiList;
 After a successful connection / execution
 - - (void) didConnectPeripheral: (CBPeripheral *) peripheral;
 After the failure of connection / / implementation
 - - (void) didFailToConnectPeripheral: (CBPeripheral *), peripheral, error: (NSError *) error;
 Executive / disconnected
 - - (void) didDisconnectPeripheral: (CBPeripheral *) peripheral, isAutoDisconnect: (BOOL) isAutoDisconnect;
 Perform / / data transmission
 - - (void) didWriteValueForCharacteristic: (CBCharacteristic *), character, error: (NSError *) error;
 @end
 
 
 Instructions for using the WiFi management class:
 A single connection can create the connection object, set the proxy, and implement the proxy method using the singleton method [POSWIFIManager shareWifiManager]
 POSConnectWithHost:port:completion: is the method of connection with the specified IP port number, block can also achieve success. The callback proxy method - (void) POSWIFIManager: (WIFIManager * manager) didConnectedToHost: (NSString *) host port: (UInt16) port; to deal with the success or failure of the operation.
 After the connection is successful, the sending data is recommended using - (void) WriteCommandWithData: (NSData *) data; and
 - - (void) WriteCommandWithData: (NSData *) data, withResponse: (POSWIFICallBackBlock) block;
 To send data, the results of the transmitted data can be block callback, or in the POSWIFIManager: (XYWIFIManager *) manager didWriteDataWithTag: (long) tag proxy method to perform the determined operation
 @protocol POSWIFIManagerDelegate <NSObject>
 / / successfully connected after the implementation of the host
 - - (void) POSWIFIManager: (POSWIFIManager *), manager, didConnectedToHost: (NSString *), host, port: (UInt16), port;
 / / disconnect
 - - (void) POSWIFIManager: (XYWIFIManager *), manager, willDisconnectWithError: (NSError *) error;
 Perform / / write data
 - - (void) POSWIFIManager: (XYWIFIManager *) manager, didWriteDataWithTag: (long) tag;
 / / method execution after the implementation of the method of receiving data
 - - (void) POSWIFIManager: (XYWIFIManager *), manager, didReadData: (NSData *), data, tag: (long), tag;
 / / disconnected after execution method
 - - (void) POSWIFIManagerDidDisconnected: (XYWIFIManager *) manager;
 @end
 
 * /

 */



#ifndef POSSDK_h
#define POSSDK_h

#import "POSBLEManager.h"
#import "POSWIFIManager.h"
#endif /* XYSDK_h */
